<template>
  <div class="pages-background">
    <v-container fluid>
      <v-row no-gutters>
        <v-spacer />
        <v-col
          cols="12"
          sm="5"
          md="4"
          lg="3"
        >
          <div class="logo">
            <logo-my-piggy-bank />
          </div>
          <v-form @submit.prevent="onSubmit">
            <v-text-field
              v-model="form.email"
              :disabled="isLoading"
              solo
              :label="$t('email')"
              prepend-inner-icon="mdi-email"
            />
            <password-field
              v-model="form.password"
              :disabled="isLoading"
              solo
            />
            <v-btn
              block
              type="submit"
              :loading="isLoading"
            >
              {{ $t('signIn') }}
            </v-btn>
            <div class="login-options">
              <v-checkbox
                v-model="form.remember"
                :label="$t('rememberMe')"
              />
              <v-spacer />
              <a href="#">{{ $t('forgotPassword') }}</a>
            </div>
          </v-form>
          <div class="register">
            <p>
              <span>{{ $t('registerCta') }}</span><!--
              -->&nbsp;<!--
              --><router-link
                :to="{ name: 'RegisterPage' }"
                v-text="$t('registerNow')"
              />
            </p>
          </div>
        </v-col>
        <v-spacer />
      </v-row>
    </v-container>
  </div>
</template>

<script>
  export default {
    name: 'LoginPage',
    data () {
      return {
        isLoading: false,
        form: {
          email: '',
          password: '',
          remember: false,
        },
      }
    },
    methods: {
      onSubmit () {
        const { email, password, remember } = this.form
        this.isLoading = true
        this.$store.dispatch('auth/login', {
          email, password, remember,
        })
          .then(() => {
            this.$router.push({ name: 'Dashboard' })
          })
          .catch(() => {
            this.$store.dispatch('toast/setOptions', {
              variant: 'error',
              timeout: '10000',
              text: this.$t('wrongCredentials'),
            })
          })
          .finally(() => {
            this.isLoading = false
          })
      },
    },
    i18n: {
      messages: {
        'pt-BR': {
          email: 'Email',
          signIn: 'Acessar',
          rememberMe: 'Continuar conectado',
          forgotPassword: 'Esqueceu a senha?',
          registerCta: 'Ainda não possui cadastro?',
          registerNow: 'Cadastre-se agora!',
          wrongCredentials: 'Login e/ou Senha incorreto(s).',
        },
        'en-US': {
          email: 'Email',
          signIn: 'Sign-in',
          rememberMe: 'Remember me',
          forgotPassword: 'Forgot password?',
          registerCta: 'Not registered yet?',
          registerNow: 'Register now!',
          wrongCredentials: 'Email and/or Password incorrect(s).',
        },
      },
    },
  }
</script>

<style lang="scss" scoped>
.logo {
  text-align: center;
  padding: 1rem 0;
}
.login-options {
  display: flex;
  align-items: center;
  a {
    text-decoration: none;
  }
  a:hover {
    text-decoration: underline;
  }
}
.register {
  padding: 2rem 0;
  p a {
    text-decoration: none;
  }
  p a:hover {
    text-decoration: underline;
  }
}
a {
  color: #0645AD;
}
</style>

<style lang="scss">
.login-options label {
  color: #333333 !important;
}
</style>
